<?php
namespace Teknisa\CMP\Modules\Solicitacao\Modules\Relatorios\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Cmp04900RelacaoDeSolicitacoesDeCompras extends \Zeedhi\Framework\Controller\Report
{
    protected $entityManager;
    protected $birtStrategy;
    protected $qr2Strategy;
    protected $stNomeRel;

    public function __construct($reportService, $entityManager,  $birtStrategy, $qr2Strategy)
    {
        $this->reportService = $reportService;
        $this->entityManager = $entityManager;
        $this->birtStrategy  = $birtStrategy;
        $this->qr2Strategy   = $qr2Strategy;
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] =
            array (
                'strategy' => $row['STRATEGY'],
                'parameterMapping' =>
                    array (
                        'VLR_NIVEL'       => 'P_NIVEL',
                        'TDTINI'          => 'P_TDTINI',
                        'TDTFIM'          => 'P_TDTFIM',
                        'CDFILIAL'        => 'L_CDFILIAL',
                        'CDPRODINICOC'    => 'P_CDPRODINICOC',
                        'CDPRODFIMCOC'    => 'P_CDPRODFIMCOC',
                        'CDPRODINI'       => 'P_CDPRODINI',
                        'DTINI'           => 'P_DTINI',
                        'DTFIM'           => 'P_DTFIM',
                        'CDGRUPFILI'      => 'L_FILGRUPFILI',
                        'IMPRIME'         => 'P_IMPRIMEOBS',
                        'CDPRODFIN'       => 'P_CDPRODFIM',
                        'IDUTPRORIGOBRIG' => 'P_IDUTPRORIGOBRIG',
                        'NRORG'           => 'NRORG'
                    ),
            );
    }
}
